poj3126——bfs

POJ 1326  对数位的bfs

Prime Path
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 12480   Accepted: 7069

Description

poj3126——bfsThe ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3

1033 8179

1373 8017

1033 1033

Sample Output

6

7

0

题意:求从一个四位数素数到另一个四位数素数所需的最短步数,每一步只能改变一位数字,且改变过程中的数必须是四位数
这是一道典型的数位搜索题,求最短路所以用bfs,难点在于模拟数的转化,另外注意边界控制
#include<iostream>

#include<cstdlib>

#include<cstdio>

#include<cstring>

#include<algorithm>

#include<queue>



using namespace std;



const int maxn=10000;



int n,m;

bool vis[maxn];

int ans;

struct node

{

    int num,step;

};



int mypow(int n,int k)

{

    int res=1;

    while(k--) res*=n;

    return res;

}



bool isprime(int n) //判断素数,由于数据不大,懒得打印素数表了

{

    for(int i=2;i*i<=n;i++){

        if(n%i==0) return false;

    }

    return true;

}



int change(int n,int i,int j) //模拟数的转化,有很多技巧方法,一定要细心

{

    int f=n/mypow(10,i+1)*mypow(10,i+1);//保留前缀

    int r=n%mypow(10,i);//保留后缀

    int mid=j*mypow(10,i); //改变中间的数

    return f+mid+r;

}



bool bfs()

{

    memset(vis,0,sizeof(vis));

    queue<node> q;

    q.push({n,0});

    vis[n]=1;

    while(!q.empty()){

        node now=q.front();

        q.pop();

        if(now.num==m){

            ans=now.step;

            return true;

        }

        for(int i=0;i<4;i++){  //从第1位到第四位

            for(int j=0;j<=9;j++){  //把所在位数字改为j

                int nextnum=change(now.num,i,j);

                if(nextnum<1000||nextnum>=maxn) continue;//边界控制

                if(vis[nextnum]||!isprime(nextnum)) continue;

                vis[nextnum]=1;

                q.push({nextnum,now.step+1});

            }

        }

    }

    return false;

}



int main()

{

    int T;cin>>T;

    while(T--){

        cin>>n>>m;

        if(bfs()) cout<<ans<<endl;

        else cout<<"Impossible"<<endl;

    }

    return 0;

}
poj3126_bfs

 

你可能感兴趣的:(poj)